<?php
/**
* @version 			SEBLOD 3.x Core
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2013 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

defined( '_JEXEC' ) or die;

// -- Initialize
require_once dirname(__FILE__).'/config.php';
$cck	=	CCK_Rendering::getInstance( $this->template );
if ( $cck->initialize() === false ) { return; }

$nameForm	=	$cck->getStyleParam( 'nameForm', '' );

$id_enfant				=	$cck->getFields( "ID element", '', false )[0];
$libelle_enfant			=	$cck->getFields( "TITRE element", '', false )[0];
$id_parent				=	$cck->getFields( "alias du PARENT - champ texte alias", '', false )[0];
$fo_question_suivante	=	$cck->getFields( "LIBELLE - apparait dans le petit carre vert", '', false )[0];

$doc	=	JFactory::getDocument();
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$cck->template. '/css/style.css' );
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$cck->template. '/css/bootstrap.min.css' );
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$cck->template. '/css/jquery.jOrgChart.css' );
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$cck->template. '/css/custom.css' );
$doc->addStyleSheet( JURI::root( true ).'/templates/'.$cck->template. '/css/prettify.css' );

$doc->addScript( JURI::root( true ).'/templates/'.$cck->template. '/includes/prettify.js' );
$doc->addScript( JURI::root( true ).'/templates/'.$cck->template. '/includes/jquery.jOrgChart.js' );

// -- Render
?>
<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/jquery-ui.min.js"></script>
<script>
    jQuery(document).ready(function() {
        jQuery("#org").jOrgChart({
            chartElement : '#chart',
            dragAndDrop  : true
        });
    });
    </script>
<div id="<?php echo $cck->id; ?>" class="<?php echo $cck->id_class; ?>cck-f100 cck-pad-<?php echo $cck->getStyleParam( 'position_margin', '10' ); ?>">
    <div>
    <?php
	$css		=	array();
	$items		=	$cck->getItems();
	$positions	=	$cck->getPositions();
	// echo '<pre>';print_r($positions);echo '</pre>';
	
	
	
	unset( $positions['hidden'] );
	if ( count( $items ) ) { ?>
		<table<?php echo $class_table; ?>>
			<?php
			$head	=	'';
			$thead	=	false;
			foreach ( $positions as $name=>$position ) {
				$class		=	$position->css;
				$css[$name]	=	$class ? ' class="'.$class.'"' : '';
				$legend		=	( $position->legend ) ? $position->legend : ( ( $position->legend2 ) ? $position->legend2 : '' );
				$width		=	$cck->w( $name );
				$width		=	( $width ) ? ' width="'.$width.'"' : '';
				if ( $legend || $width ) {
					if ( $legend ) {
						$thead	=	true;
					}
					$head		.=	'<th'.$css[$name].$width.'>'.$legend.'</th>';
				}
			}
			
			
			/*joachim tri*/
			
			$idQuestionArray=array();
			$questionArray=array();
			$foTitleArray=array();
			$idParentArray=array();
			$idParentNoParentArray=array();
			
			foreach ( $items as $item ) {
				$stat=0;
				$keys=array_keys($item->me);
				foreach($keys as $k){
					$content	=	$item->renderField( $item->getName($k) );
					if($item->getName($k)==$id_enfant)
						$idQuestionArray[]=$content;
					if($item->getName($k)==$libelle_enfant)
						$questionArray[]=$content;
					if($item->getName($k)==$fo_question_suivante)
						$foTitleArray[]=$content;
					if($item->getName($k)==$id_parent){
						if($content=='')
							$idParentNoParentArray[]=$content;
						
						$idParentArray[]=$content;
					}
					
					// echo $content.' ';
				}
				// echo '</br>';					
			}
			

			
			/*pour rajouter le titre dans l'arbre*/
			for($i=0;$i<count($foTitleArray);$i++){
				if($foTitleArray[$i]!='')
					$questionArray[$i]=$questionArray[$i].'---'.$foTitleArray[$i];
				else
					$questionArray[$i]=$questionArray[$i];
			}
			/*fin pour rajouter le titre dans l'arbre*/
			
			function searchFils($search, $idArr, $idParents, $questions, &$rendu){
				$tempRendu=array();
				foreach($search as $key){
					// echo $questions[$key].' : ';
					$tempRendu[$idArr[$key]]=$questions[$key];
				}
					
				if(count($tempRendu)>0)
					$rendu[$idParents[$search[0]]]=$tempRendu;
				// if(count($search)>0)
					// echo '<br/>';
				foreach($search as $key){
					$keys	=	array_keys ( $idParents, $idArr[$key] );
					
					searchFils($keys, $idArr, $idParents, $questions, $rendu);
				}
				
				return $rendu;
			}
			
			$rendu=array();
			/*test*/
			// echo '<pre>';print_r($idParentArray);//probleme vient de la
			/*fin test*/
				$countParent=count($idParentNoParentArray);
				$parentId = $idParentNoParentArray[0];
				$keys	=	array_keys ( $idParentArray, $parentId );//cherche tous ceux qui ont comme parent id $parentId
				$renduFinal=searchFils($keys, $idQuestionArray, $idParentArray, $questionArray, $rendu);
				
			// }
			/**/
			// echo '<pre>';print_r($renduFinal);echo '</pre>';
			function arbRecursif($clefParent, $renduFinal){
						
						if(array_key_exists($clefParent , $renduFinal)){
								echo '<ul>';
// die('ca marche !');
								foreach($renduFinal[$clefParent] as $ssval=>$sousValues){

									echo '<li><span class="idE-'.$ssval.'" rel="'.$ssval.'">'.$sousValues.'</span>';
									arbRecursif($ssval, $renduFinal);
									echo '</li>';
								}
								echo '</ul>';
						}
						
						echo '</li>';
			}
			// echo '<pre>';print_r($renduFinal);
			echo '<div id="result_ajax"></div>
			
			<div id="result_arbre">
			<ul id="org" style="display:none"><li>'.$nameForm.'<ul>';
			
			foreach($renduFinal as $clef=>$final){
				if($clef==''){
					
					foreach($final as $clefParent=>$renduF){
						echo '<li><span class="idE-'.$clefParent.'" rel="'.$clefParent.'">'.$renduF.'</span>';
						arbRecursif($clefParent, $renduFinal, $clefParent);
					}
				}
				
			}
			
			
			echo '</ul></ul></div>';
            ?>
			<div id="chart" class="orgChart"></div>
            
			<script>
        jQuery(document).ready(function() {
            
            /* Custom jQuery for the example */
            jQuery("#show-list").click(function(e){
                e.preventDefault();
                
                jQuery('#list-html').toggle('fast', function(){
                    if(jQuery(this).is(':visible')){
                        jQuery('#show-list').text('Hide underlying list.');
                        jQuery(".topbar").fadeTo('fast',0.9);
                    }else{
                        jQuery('#show-list').text('Show underlying list.');
                        jQuery(".topbar").fadeTo('fast',1);                  
                    }
                });
            });
            
            jQuery('#list-html').text(jQuery('#org').html());
            
            jQuery("#org").bind("DOMSubtreeModified", function() {
                jQuery('#list-html').text('');
                
                jQuery('#list-html').text(jQuery('#org').html());
                
                prettyPrint();                
            });
        });
    </script>
		</table>
	<?php } ?>
    </div>
</div>
<?php
// -- Finalize
$cck->finalize();
?>